﻿--[[****************************************************************
	Pet! v1.00

	Author: Evil Duck
	****************************************************************

	For the game World of Warcraft
	Pet comparator.

	****************************************************************]]

-- 1.00 First version


local _;
--SLASH_DROPCOUNT1 = "/pet";

local addonName,PRIVATE=...;	-- Blizzard passes us the addon name and a table to all addon files in the ellipsis variable
PRIVATE.Code={};				-- create a subtable to store our utility functions so we can call them from anywhere in our addon without making them global
local pet=PRIVATE.Code;			-- get a reference to our functions table with a friendly/short name

PRIVATE.frame=CreateFrame("Frame",nil,UIParent);
local frame=PRIVATE.frame;
--frame:RegisterEvent("ADDON_LOADED");
frame:RegisterEvent("PET_BATTLE_OPENING_DONE");
frame:RegisterEvent("PET_JOURNAL_LIST_UPDATE");

local pets={};
local RESCANBATTLEPETS=2;	-- delay for filtered battle pet scan

local Basic="|cFF00FFFF";
local Green="|cFF00FF00";
local Red="|cFFFF0000";
local Blue="|cFF0000FF";		-- blue
local lBlue="|cFF6060FF";		-- light blue
local hBlue="|cFEA0A0FF";		-- highlight
local Yellow="|cFFFFFF00";
local dYellow="|cFF808000";
local White="|cFFFFFFFF";
local Purple="|cFFFF00FF";
local lPurple="|cFFFF80FF";
local dBrown="|cFF804C33";
local Gray="|cFF909090";
local Orange="|cFFE04224";
local Pink="|cFFFFC5C5";

function frame.OnEvent(_,event,...)
	if (frame[event]) then return frame[event](...); end end

--function frame.ADDON_LOADED()
--	frame:Unregister("ADDON_LOADED");
--	RescanBattlePets=RESCANBATTLEPETS;
--end

function frame.PET_JOURNAL_LIST_UPDATE()
print("PET_JOURNAL_LIST_UPDATE");
	RescanBattlePets=(RescanBattlePets or 0)+RESCANBATTLEPETS;
end

function frame.PET_BATTLE_OPENING_DONE()
	local buf={};
	for i=1,3 do
		buf[i]={};
		buf[i].speciesID=C_PetBattles.GetPetSpeciesID(2,i);					-- 1=player, 2=opponent
		buf[i].rarity=C_PetBattles.GetBreedQuality(2,i);
	end
	local cO,cY,found,yours;
	for i=1,3 do
		if (buf[i].speciesID) then
			found=nil;
			_,_,_,cO=GetItemQualityColor(buf[i].rarity-1); cO="|c"..cO;
			yours="";
			for _,v in pairs(pets) do
				if (v.speciesID==buf[i].speciesID) then
					found=true;
					_,_,_,cY=GetItemQualityColor(v.rarity-1); cY="|c"..cY;
					yours=yours..cY..v.speciesName.."|r, ";
				end
			end
			found=C_PetJournal.GetPetInfoBySpeciesID(buf[i].speciesID);
			if (not found) then
				print(Orange.."Pet!:",Basic.."Opponent:",cO..found,Basic.." You:",Orange.."don't have it");
			else
				print(Orange.."Pet!:",Basic.."Opponent:",cO..found,Basic.." You:",yours:sub(1,-3));		-- cut last two characters
			end
		end
	end
end

function frame.OnUpdate(_,elapsed)
	if (not RescanBattlePets) then return; end
	RescanBattlePets=RescanBattlePets-elapsed;
	if (RescanBattlePets>=0) then return; end
	RescanBattlePets=nil;
	local filtered,total=C_PetJournal.GetNumPets();
	if (filtered<1) then return; end
	if (filtered==total) then
		wipe(pets);			-- unfiltered, so wipe for full rescan as all is shown
	end
	local petID,speciesID,level,speciesName,rarity;
	for i=1,filtered do
		petID,speciesID,_,_,level,_,_,speciesName=C_PetJournal.GetPetInfoByIndex(i);
		_,_,_,_,rarity=C_PetJournal.GetPetStats(petID)		-- 1: "Poor", 2: "Common", 3: "Uncommon", 4: "Rare", 5: "Epic", 6: "Legendary"
		pets[petID]={speciesID=speciesID,level=level,speciesName=speciesName,rarity=rarity};
	end
print("Battle pets",((filtered==total) and "fully" or "partially"),"scanned.");
end

frame:SetScript("OnEvent",frame.OnEvent);
frame:SetScript("OnUpdate",frame.OnUpdate);
